(function($) {
	$.fn.supercontainer = function(options) {
		var settings = {
			showdelete:false,
			nodelete:false,
			image_only:false,
			upload:false,
			noupload:false,
			readonly:false,
			nopreview:false,
			info:false,
			title:false,
			notitle:false,
			nolink:false,
			noscroll:false,
			align:'center',
			backgroundColor:'yellow'
		}
		if (bundle == null) {
			// init SC bundle by reading strings from the SuperContainer server
			// OPTIMIZE! cache the bundle?
			var bundle = {'FileViewPanel_confirmOverwriteMessage':'Are you sure you want to overwrite this file?'}; // FIX!!! read the strings from the SuperContainer server
		}
		return this.each(function() {
			// If options exist, lets merge them
			// with our default settings
			if (options) {
				$.extend(settings, options);
			}

			// supercontainer init code here
			var $this = $(this);
			$this
					.bind(
					'dragenter',
					function(e) {
						e.preventDefault();
						e.stopPropagation();
					}
					)
					.bind(
					'dragover',
					function(e) {
						e.preventDefault();
						e.stopPropagation();
					}
					)
					.bind(
					'drop',
					function(e) {
						if ($('#download').length) {
							if (!confirm( bundle.FileViewPanel_confirmOverwriteMessage)) return false;
						}
						if (e.originalEvent.dataTransfer.files == undefined) {
							alert('Drag-and-drop uploads are not supported on this computer');
						} else if (e.originalEvent.dataTransfer.files.length) {
							e.preventDefault();
							e.stopPropagation();
							if (e.originalEvent.dataTransfer.files.length > 1) {
								alert('Only single-file uploads are supported at this time');
								return;
							}

							supercontainer.upload(options.URL, e.originalEvent.dataTransfer.files);
						}
					}
					);


			$this.click(function(event) {
				alert('You clicked ' + this);
			})
			$this.addClass('supercontainer').height(100).css('backgroundColor', settings.backgroundColor);
		});

	}
})(jQuery);

var supercontainer = {
	//xready : function()
	//{
	//	/*
	//	 $(document).keydown(function(event) {
	//	 if (event.keyCode == 8 || event.keyCode == 46) {
	//	 event.preventDefault();
	//	 event.stopPropagation();
	//	 //alert('You pressed delete');
	//	 var form = $('#delete_form').get(0);
	//	 if (form != null && form.onsubmit()) {
	//	 form.submit();
	//	 }
	//	 }
	//	 });
	//	 */
	//	//$('div#uploadTarget')
	//	$('body')
	//			.bind(
	//			'dragenter',
	//			function(e) {
	//				e.preventDefault();
	//				e.stopPropagation();
	//			}
	//			)
	//			.bind(
	//			'dragover',
	//			function(e) {
	//				e.preventDefault();
	//				e.stopPropagation();
	//			}
	//			)
	//			.bind(
	//			'drop',
	//			function(e) {
	//				if ($('#download').length) {
	//					if (!confirm(bundle.FileViewPanel_confirmOverwriteMessage)) return false;
	//				}
	//				if (e.originalEvent.dataTransfer.files == undefined) {
	//					alert('Drag-and-drop uploads are not supported on this computer');
	//				} else if (e.originalEvent.dataTransfer.files.length) {
	//					e.preventDefault();
	//					e.stopPropagation();
	//					if (e.originalEvent.dataTransfer.files.length > 1) {
	//						alert('Only single-file uploads are supported at this time');
	//						return;
	//					}
	//
	//					//dnd.createFileQueue(e.originalEvent.dataTransfer.files);
	//					dnd.upload(e.originalEvent.dataTransfer.files);
	//				}
	//			}
	//			);
	//},

	upload : function(url, files)
	{
		// This is a work-around for Safari occaisonally hanging when doing a
		// file upload.  For some reason, an additional HTTP request for a blank
		// page prior to sending the form will force Safari to work correctly.

		$.get('/file/blank.html');

		var http = new XMLHttpRequest();

		http.addEventListener(
				'load',
				function(e) {

				},
				false
				);
		http.upload.onprogress = function(e) {
			if (e.lengthComputable) {
				var percent = (100 * e.loaded / e.total).toFixed(0);
				$('#wait p').text('Progress: ' + percent + '%');
			} else {
				//$('#wait').text('Progress: ' + e.loaded);
			}
		}

		if (typeof(FormData) != 'undefined') {
			var form = new FormData();

			form.append('path', '/');

			for (var i = 0; i < files.length; i++) {
				form.append('file[]', files[i]);
			}

			http.onreadystatechange = function() {
				if (http.readyState == 1) {
					// sending
				} else if (http.readyState == 2) {
					// done sending, headers received
					//document.getElementById('wait').style.display = 'none';
					// FIX!!! remove progress bar
					var responseCode = http.status;
					if (responseCode != 200 && responseCode != 302) {
						if (responseCode == 402) {
							alert("SuperContainer server is unlicensed, or demo mode has expired.");
						} else if (responseCode == 401) {
							alert("Invalid credentials!  The username and/or password passed to the SCSetBaseURL function are incorrect.");
						} else if (responseCode == 405) {
							alert("The specified action was denied by the server");
						} else if (responseCode == 411) {
							alert("The content-length header was missing from the request");
						} else if (responseCode == 413) {
							alert("The upload exceeded the maximum allowed size on the server");
						} else {
							alert("SuperContainer server returned an error code of " + responseCode);
						}
					} else {
						location.reload();
					}

				}
			}
			http.open('POST', url);
			http.send(form);
			//sc_wait();
		} else {
			alert('Your browser does not support standard HTML5 Drag and Drop');
		}
	}
};

function sc_wait() {
	var wait = document.getElementById('wait');
	var width = document.width || document.body.offsetWidth;
	var height = document.height || document.body.offsetHeight;
	if (!wait || !width) return true;
	wait.style.left = '' + Math.floor(width / 2 - 70) + 'px';
	wait.style.top = '' + Math.floor(height / 2 - 32) + 'px';
	wait.style.display = 'block';
	var body = document.getElementsByTagName('body')[0];
	body.style.backgroundColor = 'silver';
	body.style.color = 'gray';
	body.style.cursor = 'wait';
	return true;
}

// $(document).ready(dnd.ready);